package com.example.arva;

import android.app.Activity;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class Enviarposi extends Activity {

	private Button btnActualizar;
	private Button btnDesactivar;
	private Button btnVolver;
	private TextView lblLatitud; 
	private TextView lblLongitud;
	private TextView lblPrecision;
	private TextView lblEstado;
	
	private LocationManager locManager;
	private LocationListener locListener;
			
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.enviarposi);
            
       
        
        btnActualizar = (Button)findViewById(R.id.BtnActualizar);
        btnDesactivar = (Button)findViewById(R.id.BtnDesactivar);
        btnVolver = (Button)findViewById(R.id.BtnVolver);
        
        lblLatitud = (TextView)findViewById(R.id.LblPosLatitud);
        lblLongitud = (TextView)findViewById(R.id.LblPosLongitud);
        lblPrecision = (TextView)findViewById(R.id.LblPosPrecision);
        lblEstado = (TextView)findViewById(R.id.LblEstado);
        
    	
    	locManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
    	Location loc = locManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    	if(loc == null)
    	{
    		Toast.makeText(this, "GPS no esta activado", Toast.LENGTH_LONG).show();
    		finish();
    		return;
    	}
        
        btnActualizar.setOnClickListener(new OnClickListener() {
        	
			public void onClick(View v) {
				comenzarLocalizacion();
			}
		});
        
        btnDesactivar.setOnClickListener(new OnClickListener() {
        	
			public void onClick(View v) {
		    	locManager.removeUpdates(locListener);
			}
		});
        btnVolver.setOnClickListener(new OnClickListener() {
        	
			public void onClick(View v) {
		    	finish();
			}
		});
        
	}
	
	private void comenzarLocalizacion()
    {

	   	//Obtenemos una referencia al LocationManager
    	locManager = 
    		(LocationManager)getSystemService(Context.LOCATION_SERVICE);
    	
    	//Obtenemos la ltima posicin conocida
    	Location loc = 
    		locManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    	
    	//Mostramos la ltima posicin conocida
    	mostrarPosicion(loc);
    	
    	//Nos registramos para recibir actualizaciones de la posicin
    	locListener = new LocationListener() {
	    	public void onLocationChanged(Location location) {
	    		mostrarPosicion(location);
	    	}
	    	public void onProviderDisabled(String provider){
	    		lblEstado.setText("Provider OFF");
	    	}
	    	public void onProviderEnabled(String provider){
	    		lblEstado.setText("Provider ON ");
	    	}
	    	public void onStatusChanged(String provider, int status, Bundle extras){
	    		Log.i("", "Provider Status: " + status);
	    		lblEstado.setText("Provider Status: " + status);
	    	}
    	};
    	
    	locManager.requestLocationUpdates(
    			LocationManager.GPS_PROVIDER, 30000, 0, locListener);
    }
	
	private void mostrarPosicion(Location loc) {
    	if(loc != null)
    	{
    		Posicio appState = Posicio.getInstance();
    		appState.setState(String.valueOf(loc.getLatitude()),String.valueOf(loc.getLongitude()));
    		lblLatitud.setText("Latitud: " + String.valueOf(loc.getLatitude()));
    		lblLongitud.setText("Longitud: " + String.valueOf(loc.getLongitude()));
    		lblPrecision.setText("Precision: " + String.valueOf(loc.getAccuracy()));
    		Log.i("", String.valueOf(loc.getLatitude() + " - " + String.valueOf(loc.getLongitude())));
    	}
    	else
    	{
    		lblLatitud.setText("Latitud: (sin_datos)");
    		lblLongitud.setText("Longitud: (sin_datos)");
    		lblPrecision.setText("Precision: (sin_datos)");
    	}
    }
	
	}
